typedef struct
 {
  int x, y;             // Coordenadas iniciales de muestreo
  char ndigitos;        // nmero de digitos a mostrar
  char AX, AY;          // factor de espaciado
  char C1, C2, C3;      // colores de fondo, texto, borde

  // Datos privados y uso interno exclusivamente
  unsigned int  Flen;   // longitud de la frase actual
  char BitByte;         // bit del byte por el que va en el recorrido
  char currByte;        // byte actual dentro de la frase
 } p_Ampliada;


typedef unsigned char DacPalette256[256][3];

void setvgapalette256(DacPalette256 *PalBuf);


// Paleta para el Dyna  ( apartir del 50 podemos tocar los gradientes )
DacPalette256 Palette256;
DacPalette256 PaletteDyn = {
                                {   0,  00,  00 },
                                {  32,  00,  00 },
                                {   0,  32,  00 },
                                {  32,  32,  00 },
                                {   0,  00,  32 },
                                {  32,  00,  32 },
                                {   0,  32,  32 },
                                {  48,  48,  48 },
                                {  48,  55,  48 },
                                {  41,  50,  60 },
                                {   0,  00,  00 },
                                {  42,  00,  00 },
                                {  53,  00,  00 },
                                {   0,  10,  00 },
                                {  21,  10,  00 },
                                {  32,  10,  00 },
                                {  42,  10,  00 },
                                {  53,  10,  00 },
                                {  63,  10,  00 },
                                {   0,  21,  00 },
                                {  21,  21,  00 },
                                {  32,  21,  00 },
                                {  42,  21,  00 },
                                {  53,  21,  00 },
                                {  63,  21,  00 },
                                {  21,  32,  00 },
                                {  42,  32,  00 },
                                {  53,  32,  00 },
                                {  63,  32,  00 },
                                {   0,  42,  00 },
                                {  21,  42,  00 },
                                {  32,  42,  00 },
                                {  42,  42,  00 },
                                {  53,  42,  00 },
                                {  63,  42,  00 },
                                {   0,  53,  00 },
                                {  21,  53,  00 },
                                {  32,  53,  00 },
                                {  42,  53,  00 },
                                {  53,  53,  00 },
                                {  63,  53,  00 },
                                {  21,  63,  00 },
                                {  32,  63,  00 },
                                {  42,  63,  00 },
                                {  53,  63,  00 },
                                {  21,  00,  21 },
                                {  32,  00,  21 },
                                {  42,  00,  21 },
                                {  53,  00,  21 },
                                {  63,  00,  21 },
                                {   0,  10,  21 },
                                {  21,  10,  21 },
                                {  32,  10,  21 },
                                {  42,  10,  21 },
                                {  53,  10,  21 },
                                {  63,  10,  21 },
                                {   0,  21,  21 },
                                {  21,  21,  21 },
                                {  32,  21,  21 },
                                {  42,  21,  21 },
                                {  53,  21,  21 },
                                {  63,  21,  21 },
                                {   0,  32,  21 },
                                {  21,  32,  21 },
                                {  32,  32,  21 },
                                {  42,  32,  21 },
                                {  53,  32,  21 },
                                {  63,  32,  21 },
                                {   0,  42,  21 },
                                {  21,  42,  21 },
                                {  32,  42,  21 },
                                {  42,  42,  21 },
                                {  53,  42,  21 },
                                {  63,  42,  21 },
                                {   0,  53,  21 },
                                {  21,  53,  21 },
                                {  32,  53,  21 },
                                {  42,  53,  21 },
                                {  53,  53,  21 },
                                {  63,  53,  21 },
                                {   0,  63,  21 },
                                {  21,  63,  21 },
                                {  32,  63,  21 },
                                {  42,  63,  21 },
                                {  53,  63,  21 },
                                {  63,  63,  21 },
                                {  21,  00,  32 },
                                {  42,  00,  32 },
                                {  53,  00,  32 },
                                {  63,  00,  32 },
                                {   0,  10,  32 },
                                {  21,  10,  32 },
                                {  32,  10,  32 },
                                {  42,  10,  32 },
                                {  53,  10,  32 },
                                {  63,  10,  32 },
                                {   0,  21,  32 },
                                {  21,  21,  32 },
                                {  32,  21,  32 },
                                {  42,  21,  32 },
                                {  53,  21,  32 },
                                {  63,  21,  32 },
                                {  21,  32,  32 },
                                {  42,  32,  32 },
                                {  53,  32,  32 },
                                {  63,  32,  32 },
                                {   0,  42,  32 },
                                {  21,  42,  32 },
                                {  32,  42,  32 },
                                {  42,  42,  32 },
                                {  53,  42,  32 },
                                {  63,  42,  32 },
                                {   0,  53,  32 },
                                {  21,  53,  32 },
                                {  32,  53,  32 },
                                {  42,  53,  32 },
                                {  53,  53,  32 },
                                {  63,  53,  32 },
                                {   0,  63,  32 },
                                {  21,  63,  32 },
                                {  32,  63,  32 },
                                {  42,  63,  32 },
                                {  53,  63,  32 },
                                {  63,  63,  32 },
                                {  00,  00,  42 },
                                {  21,  00,  42 },
                                {  32,  00,  42 },
                                {  42,  00,  42 },
                                {  53,  00,  42 },
                                {  63,  00,  42 },
                                {  00,  10,  42 },
                                {  21,  10,  42 },
                                {  32,  10,  42 },
                                {  42,  10,  42 },
                                {  53,  10,  42 },
                                {  63,  10,  42 },
                                {  00,  21,  42 },
                                {  21,  21,  42 },
                                {  32,  21,  42 },
                                {  42,  21,  42 },
                                {  53,  21,  42 },
                                {  63,  21,  42 },
                                {  00,  32,  42 },
                                {  21,  32,  42 },
                                {  32,  32,  42 },
                                {  42,  32,  42 },
                                {  53,  32,  42 },
                                {  63,  32,  42 },
                                {  00,  42,  42 },
                                {  21,  42,  42 },
                                {  32,  42,  42 },
                                {  42,  42,  42 },
                                {  53,  42,  42 },
                                {  63,  42,  42 },
                                {  00,  53,  42 },
                                {  21,  53,  42 },
                                {  32,  53,  42 },
                                {  42,  53,  42 },
                                {  53,  53,  42 },
                                {  63,  53,  42 },
                                {  00,  63,  42 },
                                {  21,  63,  42 },
                                {  32,  63,  42 },
                                {  42,  63,  42 },
                                {  53,  63,  42 },
                                {  63,  63,  42 },
                                {  00,  00,  53 },
                                {  21,  00,  53 },
                                {  32,  00,  53 },
                                {  42,  00,  53 },
                                {  53,  00,  53 },
                                {  63,  00,  53 },
                                {  00,  10,  53 },
                                {  21,  10,  53 },
                                {  32,  10,  53 },
                                {  42,  10,  53 },
                                {  53,  10,  53 },
                                {  63,  10,  53 },
                                {  00,  21,  53 },
                                {  21,  21,  53 },
                                {  32,  21,  53 },
                                {  42,  21,  53 },
                                {  53,  21,  53 },
                                {  63,  21,  53 },
                                {  00,  32,  53 },
                                {  21,  32,  53 },
                                {  32,  32,  53 },
                                {  42,  32,  53 },
                                {  53,  32,  53 },
                                {  63,  32,  53 },
                                {  00,  42,  53 },
                                {  21,  42,  53 },
                                {  32,  42,  53 },
                                {  42,  42,  53 },
                                {  53,  42,  53 },
                                {  63,  42,  53 },
                                {  00,  53,  53 },
                                {  21,  53,  53 },
                                {  32,  53,  53 },
                                {  42,  53,  53 },
                                {  53,  53,  53 },
                                {  63,  53,  53 },
                                {  00,  63,  53 },
                                {  21,  63,  53 },
                                {  32,  63,  53 },
                                {  42,  63,  53 },
                                {  53,  63,  53 },
                                {  63,  63,  53 },
                                {  21,  00,  63 },
                                {  32,  00,  63 },
                                {  42,  00,  63 },
                                {  53,  00,  63 },
                                {  00,  10,  63 },
                                {  21,  10,  63 },
                                {  32,  10,  63 },
                                {  42,  10,  63 },
                                {  53,  10,  63 },
                                {  63,  10,  63 },
                                {  00,  21,  63 },
                                {  21,  21,  63 },
                                {  32,  21,  63 },
                                {  42,  21,  63 },
                                {  53,  21,  63 },
                                {  63,  21,  63 },
                                {  00,  32,  63 },
                                {  21,  32,  63 },
                                {  32,  32,  63 },
                                {  42,  32,  63 },
                                {  53,  32,  63 },
                                {  63,  32,  63 },
                                {  00,  42,  63 },
                                {  21,  42,  63 },
                                {  32,  42,  63 },
                                {  42,  42,  63 },
                                {  53,  42,  63 },
                                {  63,  42,  63 },
                                {  00,  53,  63 },
                                {  21,  53,  63 },
                                {  32,  53,  63 },
                                {  42,  53,  63 },
                                {  53,  53,  63 },
                                {  63,  53,  63 },
                                {  21,  63,  63 },
                                {  32,  63,  63 },
                                {  42,  63,  63 },
                                {  53,  63,  63 },
                                {  63,  62,  60 },
                                {  40,  40,  41 },
                                {  32,  32,  32 },
                                {  63,  00,  00 },
                                {  00,  63,  00 },
                                {  63,  63,  00 },
                                {  00,  00,  63 },
                                {  63,  00,  63 },
                                {  00,  63,  63 },
                                {  63,  63,  63 }
                           };



//unsigned char BombMovs[16][18][3] = {

// BLOQUE / FILA / COLUMNA
unsigned char BombMovs[3][18][16] = {
                               {
                                {   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0 },
                                {   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,  12,   0 },
                                {   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,  12,   0,  12,   0,   0,   0 },
                                {   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,  12,   0,  12,  12,   0 },
                                {   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,  10,  12,  10,   0,   0 },
                                {   0,   0,   0,   0,   0,   0,  10,  10,  10,  10,   0,  10, 255,  10,   0,   0 },
                                {   0,   0,   0,   0,  10,  10,  51, 255,  51,  51,  10, 255,  33,  10,   0,   0 },
                                {   0,   0,   0,  10,  51,   0,  51,  13,  51,  13,  10,   0,  10,   0,   0,   0 },
                                {   0,   0,  10,  51, 255,  51,  13,  51,  51,  51,  51,  10,  10,  10,   0,   0 },
                                {   0,   0,  10,   0, 255,  13,  51,  13,  51,  13,  51,  13,  51,  10,   0,   0 },
                                {   0,  10,  51, 255,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  10,   0 },
                                {   0,  10,  51,   0,  51,  13,  51,  13,  51,  13,  51,  13,  51,  13,  10,   0 },
                                {   0,  10,  13,  51,  51,  51,  13,  51,  51,  51,  13,  51,  51,  51,  10,   0 },
                                {   0,  10,  51,  13,  51,  13,  51,  13,  51,  13,  51,  13,  51,  13,  10,   0 },
                                {   0,   0,  10,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  10,   0,   0 },
                                {   0,   0,  10,  13,  51,  13,  51,  13,  51,  13,  51,  13,  51,  10,   0,   0 },
                                {   0,   0,   0,  10,  51,  51,  13,  51,  51,  51,  51,  51,  10,   0,   0,   0 },
                                {   0,   0,   0,   0,  10,  10,  51,  13,  51,  13,  10,  10,   0,   0,   0,   0 }
                               },
                               {
                                {   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0 },
                                {   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,  12,   0,   0,  33 },
                                {   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,  33,   0,  33,   0,  12 },
                                {   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,  10,  12,  10 },
                                {   0,   0,   0,   0,   0,   0,   0,  10,  10,  10,  10,   0,  10,  10, 255,  10 },
                                {   0,   0,   0,   0,  10,  10,  10,  51, 255,  51,  51,  10, 255, 255,  33,  10 },
                                {   0,   0,   0,  10,  51,  51,  51,  51,  13,  51,  13,  10,   0,   0,  10,   0 },
                                {   0,   0,  10,  51,  13,  51,  51,  13,   0,  51,  51,  51,  10,  10,  10,  10 },
                                {   0,   0,  10,  51,  51,  51,  13, 255, 255,  51,  13,  51,  13,  13,  51,  10 },
                                {   0,  10,  51,  51,  51,  51,   0, 255, 255,  51,  51,  51,  51,  51,  51,  51 },
                                {   0,  10,  51,  13,  13,  51, 255,  51,  13,  51,  13,  51,  13,  13,  51,  13 },
                                {   0,  10,  51,  51,  51,  51,   0,  51,  13,  51,  13,  51,  13,  13,  51,  13 },
                                {   0,  10,  13,  51,  51,  51,   0,  13,  51,  51,  51,  13,  51,  51,  51,  51 },
                                {   0,  10,  51,  13,  51,  51,  13,  51,  13,  51,  13,  51,  13,  13,  51,  13 },
                                {   0,   0,  10,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  10 },
                                {   0,   0,  10,  13,  51,  51,  13,  51,  13,  51,  13,  51,  13,  13,  51,  10 },
                                {   0,   0,   0,  10,  51,  51,  51,  13,  51,  51,  51,  51,  51,  51,  10,   0 },
                                {   0,   0,   0,   0,  10,  10,  10,  51,  13,  51,  13,  10,  10,  10,   0,   0 }
                               },
                               {
                                {   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0 },
                                {   0,  10,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0 },
                                {   0,  10,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,  12,   0,  12,   0 },
                                {   0,  10,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,  12,   0,  12 },
                                {   0,  10,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,  10,  12,  10 },
                                {   0,  10,   0,   0,   0,   0,   0,   0,  10,  10,  10,  10,   0,  10, 255,  10 },
                                {   0,  10,   0,   0,   0,   0,  10,  10,  51,  51,  51,  51,  10, 255,  33,  10 },
                                {   0,  10,   0,   0,   0,  10,  51,  13,  51,  13, 255,  13,  10,   0,  10,   0 },
                                {   0,  10,   0,   0,  10,  51,  13,  51,  13,  51,  51,  51,  51,  10,  10,  10 },
                                {   0,  10,   0,   0,  10,  13,  13,  13,  51,  13,  51, 255, 255,  13,  51,  10 },
                                {   0,  10,   0,  10,  51,  13,  51,  51,  51,  51,  51,  51,  51,   0,  51,  51 },
                                {   0,  10,   0,  10,  51,  13,  51,  13,  51,  13,  51,  13,  51,  13, 255,  13 },
                                {   0,  10,   0,  10,  13,  51,  51,  51,  13,  51,  51,  51,  51,  51,   0,  51 },
                                {   0,  10,   0,  10,  51,  13,  51,  13,  51,  13,  51,  13,  51,  13,   0,  13 },
                                {   0,  10,   0,   0,  10,  51,  51,  51,  51,  51,  51,  51,  51,  51,  51,  10 },
                                {   0,  10,   0,   0,  10,  13,  51,  13,  51,  13,  51,  13,  51,  13,  51,  10 },
                                {   0,  10,   0,   0,   0,  10,  51,  51,  13,  51,  51,  51,  51,  51,  10,   0 },
                                {   0,  10,   0,   0,   0,   0,  10,  10,  51,  13,  51,  13,  10,  10,   0,   0 },
                               }
                                };

unsigned char DynaMovs[3][23][23] = {
                               {
                                {   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,  },
                                {   0,   0,   0,   0,   0,   0,   0,   0,   0,  10,  10,  10,  10,  10,  10,   0,   0,   0,   0,  10,  10,   0,   0,  },
                                {   0,   0,   0,   0,   0,   0,   0,  10,  10,   1,  11,  12,  12,  11,  11,  10,   0,   0,  10,  29,  35,  10,   0,  },
                                {   0,   0,   0,   0,   0,   0,  10,  11,  11,  12,  12,  12,  12,  12,  11,  11,  10,  10,  10,  35,  29,  10,   0,  },
                                {   0,   0,   0,   0,   0,   0,  10,  11,  12,  12,  12,  12,  12,  12,  12,  11,  11,  10,   0,  10,  10,   0,   0,  },
                                {   0,   0,   0,   0,   0,  10,  23,  24,  23,  24,  23,  11,  12,  12,  12,  12,  11,  10,   0,   0,   0,   0,   0,  },
                                {   0,   0,   0,   0,   0,  10,  24,  33,  10,  28,  28,  23,  11,  12,  12,  12,  12,  10,   0,   0,   0,   0,   0,  },
                                {   0,   0,   0,   0,   0,  10,  23,  28,  10,  28,  33,  24,  11,  12,  12,  12,  11,  10,   0,   0,   0,   0,   0,  },
                                {   0,   0,   0,   0,   0,  10,  24,  28,  10,  33,  28,  24,  11,  12,  12,  12,  11,  10,   0,   0,   0,   0,   0,  },
                                {   0,   0,   0,   0,   0,  10,  23,  24,  23,  24,  23,  11,  12,  12,  12,  11,  10,  10,   0,   0,   0,   0,   0,  },
                                {   0,   0,   0,   0,   0,   0,  10,  12,  12,  12,  10,  10,  10,  11,  11,  10,  10,   0,   0,   0,   0,   0,   0,  },
                                {   0,   0,   0,   0,   0,   0,   0,  10,  10,  10,  17,  28,  17,  10,  10,  10,   0,   0,   0,   0,   0,   0,   0,  },
                                {   0,   0,   0,   0,   0,   0,  10,  12,  18,  10,  28,  28,  28,  10,  11,  10,   0,   0,   0,   0,   0,   0,   0,  },
                                {   0,   0,   0,   0,   0,   0,  10,  12,  17,  10,  33,  28,  23,  10,   1,  10,   0,   0,   0,   0,   0,   0,   0,  },
                                {   0,   0,   0,   0,   0,   0,  10,  33,  28,  10,  10,  10,  10,  10,  10,  10,   0,   0,   0,   0,   0,   0,   0,  },
                                {   0,   0,   0,   0,   0,   0,  10,  12,  17,  10,  29,  35,  29,  10,  10,  10,   0,   0,   0,   0,   0,   0,   0,  },
                                {   0,   0,   0,   0,   0,   0,   0,  10,  10,  10,  10,  10,  10,  10,  10,   0,   0,   0,   0,   0,   0,   0,   0,  },
                                {   0,   0,   0,   0,   0,   0,   0,   0,  10,  28,  33,  28,  33,  28,  10,   0,   0,   0,   0,   0,   0,   0,   0,  },
                                {   0,   0,   0,   0,   0,   0,   0,  10,  10,  10,  10,  10,  10,  10,  10,  10,   0,   0,   0,   0,   0,   0,   0,  },
                                {   0,   0,   0,   0,   0,  10,  10,  10,  10,  35,  29,  35,  29,  10,  10,  10,  10,  10,   0,   0,   0,   0,   0,  },
                                {   0,   0,   0,   0,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,   0,   0,   0,   0,  },
                                {   0,   0,   0,   0,   0,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,   0,   0,   0,   0,   0,  },
                                {   0,   0,   0,   0,   0,   0,   0,  10,  10,  10,  10,  10,  10,  10,  10,  10,   0,   0,   0,   0,   0,   0,   0,  }
                               },
                               {
                                {   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,  },
                                {   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,  10,  10,  10,  10,  10,  10,   0,   0,   0,  10,  10,   0,   0,  },
                                {   0,   0,   0,   0,   0,   0,   0,   0,  10,  10,   1,  11,  12,  12,  11,  11,  10,   0,  10,  35,  29,  10,   0,  },
                                {   0,   0,   0,   0,   0,   0,   0,  10,  11,  12,  12,  12,  12,  12,  12,  12,  11,  10,  10,  29,  35,  10,   0,  },
                                {   0,   0,   0,   0,   0,   0,  10,  11,  12,  12,  12,  12,  12,  12,  12,  12,  11,  10,  10,  10,  10,   0,   0,  },
                                {   0,   0,   0,   0,   0,   0,  10,  23,  24,  23,  11,  12,  12,  12,  12,  12,  12,   1,  10,   0,   0,   0,   0,  },
                                {   0,   0,   0,   0,   0,   0,  10,  24,  10,  28,  24,  11,  12,  12,  12,  12,  12,  11,  10,   0,   0,   0,   0,  },
                                {   0,   0,   0,   0,   0,   0,  10,  23,  10,  33,  24,  11,  12,  12,  12,  12,  12,  11,  10,   0,   0,   0,   0,  },
                                {   0,   0,   0,   0,   0,   0,  10,  24,  10,  28,  24,  11,  12,  12,  12,  12,  12,  11,  10,   0,   0,   0,   0,  },
                                {   0,   0,   0,   0,   0,   0,  10,  23,  24,  23,  11,  12,  12,  12,  12,  12,  11,  10,  10,   0,   0,   0,   0,  },
                                {   0,   0,   0,   0,   0,  10,  10,  10,   1,  11,  12,  12,  10,  10,  10,  11,  10,  10,   0,   0,   0,   0,   0,  },
                                {   0,   0,   0,   0,  10,  29,  35,  10,  10,  10,  10,  10,  28,  23,  18,  10,  10,   0,   0,   0,   0,   0,   0,  },
                                {   0,   0,   0,   0,  10,  35,  10,  10,  18,  24,  18,  10,  24,  28,  24,  18,  10,  10,   0,   0,   0,   0,   0,  },
                                {   0,   0,   0,   0,   0,  10,  28,  10,  18,  23,  18,  17,  10,  23,  28,  10,  35,  10,   0,   0,   0,   0,   0,  },
                                {   0,   0,   0,   0,   0,  10,  28,  10,  33,  28,  10,  10,  10,  10,  10,  35,  29,  10,   0,   0,   0,   0,   0,  },
                                {   0,   0,   0,   0,   0,   0,  10,  10,  18,  17,  18,  17,  18,  12,  10,  10,  10,   0,   0,   0,   0,   0,   0,  },
                                {   0,   0,   0,   0,   0,   0,   0,  10,  10,  28,  33,  24,  12,  12,  12,  10,  35,  10,   0,   0,   0,   0,   0,  },
                                {   0,   0,   0,   0,   0,  10,  10,  10,  28,  33,  24,  17,  10,  10,  10,  10,  35,  10,   0,   0,   0,   0,   0,  },
                                {   0,   0,   0,   0,   0,  10,  35,  35,  10,  24,  18,  10,  10,  28,  28,  10,  29,  10,   0,   0,   0,   0,   0,  },
                                {   0,   0,   0,   0,   0,   0,  10,  29,  35,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,   0,   0,   0,   0,  },
                                {   0,   0,   0,   0,   0,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,   0,   0,   0,  },
                                {   0,   0,   0,   0,   0,   0,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,   0,   0,   0,   0,  },
                                {   0,   0,   0,   0,   0,   0,   0,   0,  10,  10,  10,  10,  10,  10,  10,  10,  10,   0,   0,   0,   0,   0,   0,  }
                               },
                               {
                                {   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,  },
                                {   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,  10,  10,  10,  10,  10,  10,  10,   0,   0,  10,  10,   0,   0,  },
                                {   0,   0,   0,   0,   0,   0,   0,   0,   0,  10,   1,  11,  12,  12,  12,  11,  11,  10,  10,  35,  35,  10,   0,  },
                                {   0,   0,   0,   0,   0,   0,   0,   0,  10,  11,  12,  12,  12,  12,  12,  12,  12,  11,  10,  35,  29,  10,   0,  },
                                {   0,   0,   0,   0,   0,   0,   0,   0,  10,  12,  12,  12,  12,  12,  12,  12,  12,  12,  11,  10,  10,   0,   0,  },
                                {   0,   0,   0,   0,   0,   0,   0,  10,  23,  24,  23,  24,  23,  24,  23,  11,  12,  12,  11,  10,   0,   0,   0,  },
                                {   0,   0,   0,   0,   0,   0,   0,  10,  10,  33,  28,  10,  28,  33,  28,  24,  11,  12,  11,  10,   0,   0,   0,  },
                                {   0,   0,   0,   0,   0,   0,   0,  10,  10,  28,  33,  10,  33,  28,  33,  24,  11,  12,  12,  10,   0,   0,   0,  },
                                {   0,   0,   0,   0,   0,   0,   0,  10,  10,  28,  28,  10,  28,  28,  28,  24,  11,  12,  11,  10,   0,   0,   0,  },
                                {   0,   0,   0,   0,   0,   0,   0,  10,  23,  24,  23,  24,  23,  24,  23,  11,  12,  12,   1,  10,   0,   0,   0,  },
                                {   0,   0,   0,   0,   0,   0,   0,   0,  10,  10,  18,  10,  10,  10,   1,  11,  12,   1,  10,   0,   0,   0,   0,  },
                                {   0,   0,   0,   0,   0,   0,   0,  10,  29,  35,  10,  10,  23,  18,  10,  10,  10,  10,  10,   0,   0,   0,   0,  },
                                {   0,   0,   0,   0,   0,   0,   0,  10,  35,  10,  24,  33,  28,  24,  10,  24,  12,  10,  18,  10,   0,   0,   0,  },
                                {   0,   0,   0,   0,   0,   0,   0,  10,  10,  24,  33,  28,  23,  18,  10,  24,  12,  10,  17,  18,  10,   0,   0,  },
                                {   0,   0,   0,   0,   0,   0,   0,   0,  10,  10,  28,  24,  18,  10,  10,  10,  10,  10,  10,  10,  10,   0,   0,  },
                                {   0,   0,   0,   0,   0,   0,   0,   0,  10,  18,  10,  10,  10,  18,  17,  18,  17,  10,  10,  35,  10,   0,   0,  },
                                {   0,   0,   0,   0,   0,   0,  10,  10,  18,  28,  18,  17,  18,  18,  12,  33,  24,  10,  10,  10,   0,   0,   0,  },
                                {   0,   0,   0,   0,   0,  10,  29,  10,  33,  28,  23,  10,  10,  10,  23,  28,  33,  24,  10,   0,   0,   0,   0,  },
                                {   0,   0,   0,   0,   0,  10,  35,  35,  10,  23,  10,  10,  10,  10,  10,  24,  28,  10,  35,  10,   0,   0,   0,  },
                                {   0,   0,   0,   0,   0,   0,  10,  35,  29,  10,  10,  10,  10,  10,  10,  10,  10,  10,  29,  10,   0,   0,   0,  },
                                {   0,   0,   0,   0,   0,   0,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  29,  10,  10,  10,   0,   0,  },
                                {   0,   0,   0,   0,   0,   0,   0,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,   0,   0,   0,  },
                                {   0,   0,   0,   0,   0,   0,   0,   0,   0,  10,  10,  10,  10,  10,  10,  10,  10,  10,   0,   0,   0,   0,   0,  }
                               }
                                };